<template>
  <div class="app-container">
    
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="大楼名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入大楼名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="大楼状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择大楼状态（0正常 1停用）" clearable size="small">
          <el-option v-for="dict in statusDictDatas" :key="parseInt(dict.value)" :label="dict.label" :value="parseInt(dict.value)"/>          
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['system:building:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="info" plain icon="el-icon-sort" size="mini" @click="toggleExpandAll">展开/折叠</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <!-- <el-table v-loading="loading" :data="list"> -->
    <el-table v-if="refreshTable" v-loading="loading" :data="list" row-key="id" :default-expand-all="isExpandAll"
            :tree-props="{children: 'children', hasChildren: 'hasChildren'}">

      <!-- <el-table-column label="大楼id" align="center" prop="id" /> -->
      <el-table-column label="大楼名称"  prop="name" />
      <!-- <el-table-column label="父大楼id" align="center" prop="parentId" /> -->
      <el-table-column label="楼层" align="center" prop="fid" />
      <el-table-column label="大楼状态" align="center" prop="status" >
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.COMMON_STATUS" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['system:building:update']">修改</el-button>

          <el-button v-if="scope.row.parentId == 0" size="mini" type="text" icon="el-icon-plus" @click="handleAdd(scope.row)"
          v-hasPermi="['system:building:create']">新增</el-button>

          <el-button v-if="scope.row.parentId !== 0" size="mini" type="text" icon="el-icon-delete"
                     @click="handleDelete(scope.row)" v-hasPermi="['system:building:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <!-- <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/> -->

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="所属大楼" prop="parentId">
          <treeselect v-model="form.parentId" :options="buildingOptions" :normalizer="normalizer" :flat="true" placeholder="选择大楼" />
        </el-form-item>
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入大楼名称" />
        </el-form-item>
        <el-form-item label="状态" prop="status">
          <el-select v-model="form.status" placeholder="请选择状态（0正常 1停用）" clearable size="small">
          <el-option v-for="dict in statusDictDatas" :key="parseInt(dict.value)" :label="dict.label" :value="parseInt(dict.value)"/>          
        </el-select>
        </el-form-item>
        <el-form-item label="楼层" prop="fid">
          <el-input v-model="form.fid" placeholder="请输入楼层id,初始为0" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listBuilding, listSimpleBuildings, createBuilding, updateBuilding, deleteBuilding, getBuilding, getBuildingPage, exportBuildingExcel } from "@/api/system/building";

import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import { getDictDatas, DICT_TYPE } from '@/utils/dict'
import {CommonStatusEnum} from '@/utils/constants'

export default {
  name: "Building",
  components: {
    Treeselect
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      // total: 0,
      // 楼层导视列表
      list: [],
      // 部门树选项
      buildingOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 是否展开
      expand: false,
      // 查询参数
      queryParams: {
        // pageNo: 1,
        // pageSize: 10,
        // parentId: null,
        name: null,
        status: null,
        // fid: null,
        // createTime: [],
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [{ required: true, message: "大楼名称不能为空", trigger: "blur" }],
        // parentId: [{ required: true, message: "父大楼id不能为空", trigger: "blur" }],
        status: [{ required: true, message: "大楼状态（0正常 1停用）不能为空", trigger: "blur" }],
      },
      // 枚举
      CommonStatusEnum: CommonStatusEnum,
      // 数据字典
      statusDictDatas: getDictDatas(DICT_TYPE.BUILDING_STATUS)
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 执行查询
      listBuilding(this.queryParams).then(response => {
        // this.list = response.data.list;
        this.list = this.handleTree(response.data, "id");
        // this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 转换数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.id,
        label: node.name,
        isDisabled: node.parentId != 0,        
        children: node.children
      };
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        name: undefined,
        parentId: undefined,
        status: undefined,
        fid: undefined,
        status: CommonStatusEnum.ENABLE,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      this.reset();

      if (row !== undefined) {
        this.form.parentId = row.id;
      }
      this.open = true;
      this.title = "添加";
      getBuildingPage().then(response => {
	        this.buildingOptions = this.handleTree(response.data.list, "id");
      });
    },
    /** 展开/折叠操作 */
    toggleExpandAll() {
      this.refreshTable = false;
      this.isExpandAll = !this.isExpandAll;
      this.$nextTick(() => {
        this.refreshTable = true;
      });
    },

    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();

      getBuilding(row.id).then(response => {
        this.form = response.data;
        if (this.form.parentId === 0) { // 无父部门时，标记为 undefined，避免展示为 Unknown
          this.form.parentId = undefined;
        }
        this.open = true;
        this.title = "修改部门";
      });
      listBuilding(row.id).then(response => {
	        this.buildingOptions = this.handleTree(response.data, "id");
      });

      // const id = row.id;
      // getBuilding(id).then(response => {
      //   this.form = response.data;
      //   this.open = true;
      //   this.title = "修改楼层导视";
      // });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateBuilding(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createBuilding(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {

      this.$modal.confirm('是否确认删除名称为"' + row.name + '"的数据项?').then(function() {
          return deleteBuilding(row.id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    

      // const id = row.id;
      // this.$modal.confirm('是否确认删除楼层导视编号为"' + id + '"的数据项?').then(function() {
      //     return deleteBuilding(id);
      //   }).then(() => {
      //     this.getList();
      //     this.$modal.msgSuccess("删除成功");
      //   }).catch(() => {});
    }
    /** 导出按钮操作 */
    // handleExport() {
    //   // 处理查询参数
    //   let params = {...this.queryParams};
    //   params.pageNo = undefined;
    //   params.pageSize = undefined;
    //   this.$modal.confirm('是否确认导出所有楼层导视数据项?').then(() => {
    //       this.exportLoading = true;
    //       return exportBuildingExcel(params);
    //     }).then(response => {
    //       this.$download.excel(response, '楼层导视.xls');
    //       this.exportLoading = false;
    //     }).catch(() => {});
    // }
  }
};
</script>
